// Based on some wxwidgets sample, modified heavily

/*********************************************************************
 *
 *          DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                   Version 2, December 2004
 *
 * Copyright (C) 2005-2007 Jari Komppa
 *
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 *  0. You just DO WHAT THE FUCK YOU WANT TO. 
 *
 ********************************************************************
 *
 * This is a mess, sorry about that, but it does what's intended.
 * Cheerios, 
 *     Sol
 */

#include "wx/wx.h"
#include "wx/glcanvas.h"
#include "wx/splitter.h"
#include "wx/button.h"
#include "wx/textctrl.h"
#include "wx/slider.h"
#include "wx/dcbuffer.h"
#include "wx/panel.h"
#include "wx/image.h"
#include "wx/checkbox.h"
#include "wx/stattext.h"
#include "wx/statbmp.h"
#include <gl/glu.h>

class GfxPanel;

// Declare the application class
class MyApp : public wxApp, public wxTimer
{
public:
    // Called on application startup
    virtual bool OnInit();
    virtual void Notify(); // timer
    wxSplitterWindow *vsplitter, *hsplitter;
    wxSlider     *v1, *v2, *v3, *v4, *v5;
    wxTextCtrl   *t1, *t2, *t3, *t4, *t5;
    wxStaticText *s1, *s2, *s3, *s4, *s5;
    wxCheckBox *c1, *c2, *c3, *c4;
    wxStaticBitmap *b1;
    wxBitmap *bm1;
    wxGLCanvas *glc;

    GfxPanel *w2;
};

// Declare our main frame class
class MyFrame : public wxFrame
{
public:
    // Constructor
    MyFrame(const wxString& title);

    void updateFields();

    // Event handlers
    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnScroll(wxScrollEvent& event);

private:
    // This class handles events
    DECLARE_EVENT_TABLE()
};

// Implements MyApp& GetApp()
DECLARE_APP(MyApp)

// Give wxWidgets the means to create a MyApp object
IMPLEMENT_APP(MyApp)

class GfxPanel : public wxGLCanvas { 
    DECLARE_CLASS(GfxPanel)
    DECLARE_EVENT_TABLE()

private:

    void onPaint(wxPaintEvent &event);
    void onEraseBackground(wxEraseEvent &event);
    void onIdle(wxIdleEvent &event);
    void onMouseEvent(wxMouseEvent &event);
    void createScreen();
    void render(float *vtx, int dotcount, int solid) ;

public:
    float xpos, ypos;
    GfxPanel(wxWindow *parent);
    ~GfxPanel();
};

void GfxPanel::onMouseEvent(wxMouseEvent &event)
{
    if (event.Dragging())
    {
        xpos = event.GetX();
        ypos = event.GetY();
    }
}

inline void GfxPanel::onEraseBackground(wxEraseEvent &) {}

IMPLEMENT_CLASS(GfxPanel, wxGLCanvas)

BEGIN_EVENT_TABLE(GfxPanel, wxGLCanvas)
EVT_PAINT(GfxPanel::onPaint)
EVT_ERASE_BACKGROUND(GfxPanel::onEraseBackground)
EVT_IDLE(GfxPanel::onIdle)
EVT_MOUSE_EVENTS(GfxPanel::onMouseEvent)
END_EVENT_TABLE()

GfxPanel::GfxPanel(wxWindow *parent) : wxGLCanvas(parent, wxID_ANY, wxDefaultPosition) {
}

GfxPanel::~GfxPanel() {
}


void GfxPanel::render(float *vtx, int dotcount, int solid) 
{ 
    glMatrixMode( GL_MODELVIEW );
    glPushMatrix();
    glMatrixMode( GL_PROJECTION );
    glPushMatrix();

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity( );

    wxSize s = GetSize();

    float x = (ypos - s.GetHeight()/2) / (float)(s.GetHeight()/4);
    float y = -(xpos - s.GetWidth()/2) / (float)(s.GetWidth()/4);
    float z = -1;

    float l = 1.5f / sqrt(x*x+y*y+z*z);
    x *= l;
    y *= l;
    z *= l;

    gluLookAt(x,y,z,0,0,0,1,0,0);

    float angle = GetTickCount() / 10000.0f;

    glRotatef( angle * 60.0f + 90.0f, 0.0f, 1.0f, 0.0f);

    glRotatef( angle*20.0f, 0.5f, 0.1f, 0.3f);

    glEnableClientState(GL_VERTEX_ARRAY);

    glVertexPointer(3, GL_FLOAT, 0, vtx);

    glDisable(GL_CULL_FACE);
    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
    glEnable(GL_BLEND);

    glDisable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);

    glBlendFunc(GL_ONE, GL_ONE);
    glEnable(GL_VERTEX_ARRAY);

    glPointSize(1);
    if (solid)
        glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    else
        glColor4f(0.1f, 0.1f, 0.1f, 1.0f);

    glDrawArrays(GL_POINTS, 0, dotcount);        

    glDisableClientState(GL_VERTEX_ARRAY);


    glMatrixMode( GL_PROJECTION );
    glPopMatrix();
    glMatrixMode( GL_MODELVIEW );
    glPopMatrix();
}

void GfxPanel::onPaint(wxPaintEvent &) 
{
    wxPaintDC dc(this);
    SetCurrent();

    wxSize s = GetSize();


    glShadeModel( GL_SMOOTH );

    glCullFace( GL_BACK );
    glFrontFace( GL_CCW );
    glDisable( GL_CULL_FACE );

    glDisable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);

    glClearColor( 0, 0, 0, 0 );

    glViewport( 0, 0, s.GetWidth(), s.GetHeight() );

    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );
    gluPerspective( 60.0, s.GetWidth()/(float)s.GetHeight(), 1.0, 1024.0 );

    glClear(GL_COLOR_BUFFER_BIT);    

    MyApp * app = (MyApp*)wxTheApp;

    float dance = app->c2->GetValue();

    float a[5];
    a[0] = (app->v1->GetValue()/1000.0f) + sin(GetTickCount() * 0.000123) * dance * 0.01f;
    a[1] = (app->v2->GetValue()/1000.0f) + sin(GetTickCount() * 0.000245) * dance * 0.01f;
    a[2] = (app->v3->GetValue()/1000.0f) + sin(GetTickCount() * 0.000445) * dance * 0.01f;
    a[3] = (app->v4->GetValue()/1000.0f) + sin(GetTickCount() * 0.000867) * dance * 0.01f;
    a[4] = (app->v5->GetValue()/1000.0f) + sin(GetTickCount() * 0.001667) * dance * 0.01f;

    static float x=0, y=0, z=0;

    float minx, miny, minz;
    float maxx, maxy, maxz;

    minx = maxx = x;
    miny = maxy = y;
    minz = maxz = z;

    int resize = app->c1->GetValue();
    int dotcount = 25000;
    if (app->c4->GetValue() == 0)
        dotcount = 2500;

    float vtx[3*25000];
    int i;

    for (i = 0; i < dotcount; i++)
    {
        float xx = sin(a[0] * y) - z * cos(a[1] * x);
        float yy = z * sin(a[2] * x) - cos(a[3] * y);
        float zz = a[4] * sin(x);
        x=xx;y=yy;z=zz;

        vtx[i*3+0]=x;
        vtx[i*3+1]=y;
        vtx[i*3+2]=z;

        if (minx > x) minx=x;
        if (maxx < x) maxx=x;
        if (miny > y) miny=y;
        if (maxy < y) maxy=y;
        if (minz > z) minz=z;
        if (maxz < z) maxz=z;
    }

    float xdec = (maxx+minx)/2;
    float ydec = (maxy+miny)/2;
    float zdec = (maxz+minz)/2;

#define MAX(a,b) (((a)>(b))?(a):(b))

    float scale = (1.0f/MAX((maxx-minx),MAX((maxy-miny),(maxz-minz))));
    if (!resize)
    {
        scale = 0.25f;
        xdec=ydec=zdec=0;
    }

    for (i = 0; i < dotcount; i++)
    {
        vtx[i*3+0] = (vtx[i*3+0]-xdec)*scale;
        vtx[i*3+1] = (vtx[i*3+1]-ydec)*scale;
        vtx[i*3+2] = (vtx[i*3+2]-zdec)*scale;
    }

    render(&vtx[0], dotcount, app->c3->GetValue());

    glFlush(); 
    SwapBuffers();
}

void GfxPanel::onIdle(wxIdleEvent &) {
    // create the SDL_Surface
    createScreen();  

    // refresh the panel
    Refresh(false);

    // throttle to keep from flooding the event queue
    wxMilliSleep(33);
}

void GfxPanel::createScreen() {
}

void MyApp::Notify()
{    
}


// Initialize the application
bool MyApp::OnInit()
{
    // Create the main application window
    MyFrame *frame = new MyFrame("Attractor Explorer 1.0 - http://iki.fi/sol/");
    frame->SetSize(wxSize(800, 600));    

    vsplitter = new wxSplitterWindow(frame, wxID_ANY);

    vsplitter->SetForegroundColour(1);

    wxPanel *w1 = new wxPanel(vsplitter, wxID_ANY);

    w2 = new GfxPanel(vsplitter);

    v1 = new wxSlider(w1, wxID_ANY, 1000, 0, 2000, wxPoint(0,0), wxSize(300,30));
    v2 = new wxSlider(w1, wxID_ANY, 1000, 0, 2000, wxPoint(0,80), wxSize(300,30));
    v3 = new wxSlider(w1, wxID_ANY, 1000, 0, 2000, wxPoint(0,160), wxSize(300,30));
    v4 = new wxSlider(w1, wxID_ANY, 1000, 0, 2000, wxPoint(0,240), wxSize(300,30));
    v5 = new wxSlider(w1, wxID_ANY, 1000, 0, 2000, wxPoint(0,320), wxSize(300,30));

    t1 = new wxTextCtrl(w1, wxID_ANY, "", wxPoint(200,40), wxDefaultSize, wxTE_READONLY);
    t2 = new wxTextCtrl(w1, wxID_ANY, "", wxPoint(200,120), wxDefaultSize, wxTE_READONLY);
    t3 = new wxTextCtrl(w1, wxID_ANY, "", wxPoint(200,200), wxDefaultSize, wxTE_READONLY);
    t4 = new wxTextCtrl(w1, wxID_ANY, "", wxPoint(200,280), wxDefaultSize, wxTE_READONLY);
    t5 = new wxTextCtrl(w1, wxID_ANY, "", wxPoint(200,360), wxDefaultSize, wxTE_READONLY);

    s1 = new wxStaticText(w1, wxID_ANY, wxT("a0 ="), wxPoint(172,44));
    s2 = new wxStaticText(w1, wxID_ANY, wxT("a1 ="), wxPoint(172,124));
    s3 = new wxStaticText(w1, wxID_ANY, wxT("a2 ="), wxPoint(172,204));
    s4 = new wxStaticText(w1, wxID_ANY, wxT("a3 ="), wxPoint(172,284));
    s5 = new wxStaticText(w1, wxID_ANY, wxT("a4 ="), wxPoint(172,364));

    c1 = new wxCheckBox(w1, wxID_ANY, "Normalize size", wxPoint(10,400));
    c1->SetValue(1);

    c2 = new wxCheckBox(w1, wxID_ANY, "Dance 0.01", wxPoint(140,400));

    c3 = new wxCheckBox(w1, wxID_ANY, "Bright", wxPoint(10,420));

    c4 = new wxCheckBox(w1, wxID_ANY, "High dotcount", wxPoint(140,420));
    c4->SetValue(1);

    bm1 = new wxBitmap("formula.bmp", wxBITMAP_TYPE_BMP);
    b1 = new wxStaticBitmap(w1, wxID_ANY, *bm1, wxPoint(50,450));


    vsplitter->Initialize(w1);
    vsplitter->SplitVertically(w2,w1);
    vsplitter->SetMinimumPaneSize(303);
    vsplitter->SetSashGravity(1.0);
    

    vsplitter->SetSashPosition(480);

    // Show it
    frame->Show(true);

    frame->updateFields();        

    Start(1, false);

    // Start the event loop
    return true;
}

// Event table for MyFrame
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
EVT_MENU(wxID_ABOUT, MyFrame::OnAbout)
EVT_MENU(wxID_EXIT,  MyFrame::OnQuit)
EVT_SCROLL(MyFrame::OnScroll) 
END_EVENT_TABLE()

void MyFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg;
    msg.Printf(wxT("Attractor Explorer\nCopyright 2005-2007 Jari Komppa\nhttp://iki.fi/sol/"));

    wxMessageBox(msg, wxT("About Attractor Explorer 1.0"),
        wxOK | wxICON_INFORMATION, this);
}

void MyFrame::OnQuit(wxCommandEvent& event)
{
    // Destroy the frame
    Close();
}

void MyFrame::OnScroll(wxScrollEvent& event)
{
    updateFields();
}

void MyFrame::updateFields()
{
    MyApp * app = (MyApp*)wxTheApp;
    char foo[256];
    sprintf(foo,"%3.3f",app->v1->GetValue()/1000.0f);
    app->t1->SetValue(foo);
    sprintf(foo,"%3.3f",app->v2->GetValue()/1000.0f);
    app->t2->SetValue(foo);
    sprintf(foo,"%3.3f",app->v3->GetValue()/1000.0f);
    app->t3->SetValue(foo);
    sprintf(foo,"%3.3f",app->v4->GetValue()/1000.0f);
    app->t4->SetValue(foo);
    sprintf(foo,"%3.3f",app->v5->GetValue()/1000.0f);
    app->t5->SetValue(foo);
}

MyFrame::MyFrame(const wxString& title)
: wxFrame(NULL, wxID_ANY, title)
{

    // Create a menu bar
    wxMenu *fileMenu = new wxMenu;

    // The "About" item should be in the help menu
    wxMenu *helpMenu = new wxMenu;
    helpMenu->Append(wxID_ABOUT, wxT("&About...\tF1"),
        wxT("Show about dialog"));

    fileMenu->Append(wxID_EXIT, wxT("E&xit\tAlt-X"),
        wxT("Quit this program"));

    // Now append the freshly created menu to the menu bar...
    wxMenuBar *menuBar = new wxMenuBar();
    menuBar->Append(fileMenu, wxT("&File"));
    menuBar->Append(helpMenu, wxT("&Help"));

    // ... and attach this menu bar to the frame
    SetMenuBar(menuBar);
}

